## phast 1.4+dfsg

=== Makefile ===
TMPDIR = /tmp/phast
CWD = ${PWD}

all:
	@echo "Type \"make package\" to create a tarball reflecting the current state of the CVS tree."
	(cd src; make DESTDIR=${DESTDIR} CLAPACKPATH=/usr/lib )

package:
	rm -rf ${TMPDIR}
	mkdir -p ${TMPDIR}
	cd ${TMPDIR} ; svn checkout http://compgen.bscb.cornell.edu/svnrepo/phast/trunk phast
	find ${TMPDIR}/phast -name ".svn" | xargs rm -rf
	rm -r ${TMPDIR}/phast/doc ${TMPDIR}/phast/src/lib/rphast ${TMPDIR}/phast/test ${TMPDIR}/phast/binary_install.sh
	VERSION=`cat ${TMPDIR}/phast/version | sed 's/\./_/g'` ;\
	cd ${TMPDIR} ; tar cfz ${CWD}/phast.$$VERSION.tgz phast
	rm -rf ${TMPDIR}

doc::
	(cat Doxyfile; echo "PROJECT_NUMBER=`cat version`") | doxygen -

install:
	(cd src; make install DESTDIR=${DESTDIR} )

=== test/Makefile ===
# acs 8/4/04
# simple test cases, designed to catch obvious errors
# add cases as needed

all: msa_view phyloFit phastCons

msa_view:
	@echo "*** Testing msa_view ***"
	msa_view hmrc.ss -i SS --end 10000 > hmrc.fa
	@if [[ -n `diff --brief hmrc.fa hmrc_correct.fa` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.fa -o PHYLIP > hmrc.ph
	msa_view hmrc.ph -i PHYLIP > hmrc.fa
	@if [[ -n `diff --brief hmrc.fa hmrc_correct.fa` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ph --out-format MPM --in-format PHYLIP > hmrc.mpm
	msa_view hmrc.mpm --in-format MPM > hmrc.fa
	@if [[ -n `diff --brief hmrc.fa hmrc_correct.fa` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.fa -o SS > hmrc_short_a.ss
	msa_view hmrc.ss --end 10000 -i SS -o SS > hmrc_short_b.ss
	@if [[ -n `diff --brief hmrc_short_[ab].ss` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view --seqs human,cow hmrc_short_a.ss -i SS -o SS | msa_view - -i SS > hm_a.fa
	msa_view --seqs human,cow hmrc.fa > hm_b.fa
	@if [[ -n `diff --brief hm_[ab].fa` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss --gap-strip ANY -i SS -o SS | msa_view - -i SS > hmrc_nogaps_a.fa
	msa_view hmrc.ss -i SS | msa_view - --gap-strip ANY > hmrc_nogaps_b.fa
	@if [[ -n `diff --brief hmrc_nogaps_[ab].fa` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.fa --seqs human,cow --gap-strip ALL > hm_a.fa
	msa_view hmrc_short_a.ss --seqs human,cow -i SS --gap-strip ALL > hm_b.fa
	@if [[ -n `diff --brief hm_[ab].fa` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss --start 10000 --end 20000 -i SS > hmrc_sub_a.fa
	msa_view hmrc.ss -i SS | msa_view - --start 10000 --end 20000 > hmrc_sub_b.fa
	@if [[ -n `diff --brief hmrc_sub_[ab].fa` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss --summary -i SS > hmrc_summary
	@if [[ -n `diff --brief hmrc_summary hmrc_summary_correct` ]] ; then echo "ERROR" ; exit 1 ; fi
	@echo -e "Passed all tests.\n"
	@rm -f hmrc.ph hmrc.fa hmrc.mpm hmrc_short_[ab].ss hm_[ab].fa hmrc_nogaps_[ab].fa hmrc_sub_[ab].fa hmrc_summary


# still need test for MAFs, reverse complement, aggregate, dinucs,
# category-specific stats, missing data, reorder rows.  Also, maybe
# should choose a better short test case (first 10000 bases all gaps
# in mouse and rat)

phyloFit:
	@echo "*** Testing phyloFit ***"
	phyloFit hmrc.ss --subst-mod JC69 --tree "(human, (mouse,rat), cow)" -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod jc.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod JC69 --tree "((((human,chimp), (mouse,rat)), cow), chicken)" -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod jc.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod F81 --tree "(human, (mouse,rat), cow)" -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod f81.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod HKY85 --tree "(human, (mouse,rat), cow)" -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod hky.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat), cow)" -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod rev.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod UNREST --tree "(human, (mouse,rat), cow)" -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod unrest.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod HKY85 --tree "(human, (mouse,rat), cow)" -i SS -k 4 --quiet
	@if [[ -n `diff --brief phyloFit.mod hky-dg.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat), cow)" -i SS -k 4 --quiet 
	@if [[ -n `diff --brief phyloFit.mod rev-dg.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod HKY85 --tree "(human, (mouse,rat), cow)" -i SS --EM --quiet
	@if [[ -n `diff --brief phyloFit.mod hky-em.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat), cow)" -i SS --EM --quiet
	@if [[ -n `diff --brief phyloFit.mod rev-em.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hpmrc.ss --subst-mod REV --tree "(hg16, (mm3,rn3), galGal2)" -i SS --gaps-as-bases --quiet
	@if [[ -n `diff --brief phyloFit.mod rev-gaps.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV -i SS --init-model rev.mod --post-probs --lnl --quiet
	@if [[ -n `diff --brief phyloFit.mod rev-lnl.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	@if [[ -n `diff --brief phyloFit.postprob rev.postprob` ]] ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat))" -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod rev-hmr.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss -i SS --seqs human,mouse,rat --unordered -o SS > hmr.ss
	phyloFit hmr.ss -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod rev-hmr2.mod` ]] ; then echo "ERROR" ; exit 1 ; fi  # FIXME: rev-hmr.mod and rev-hmr2.mod should be equal (eq freqs being obtained from all seqs)
	msa_view hmrc.ss -i SS --seqs human,mouse --unordered -o SS > hm.ss
	phyloFit hm.ss -i SS --quiet
	@if [[ -n `diff --brief phyloFit.mod rev-hm.mod` ]] ; then echo "ERROR" ; exit 1 ; fi  
	phyloFit hmrc.ss --subst-mod UNREST --tree "((human, mouse), cow)" -i SS --ancestor cow --quiet
	@if [[ -n `diff --brief phyloFit.mod unrest-cow-anc.mod` ]] ; then echo "ERROR" ; exit 1 ; fi
	@echo -e "Passed all tests.\n"
	@rm -f phyloFit.mod phyloFit.postprob hmr.ss hm.ss

# still need tests for dinucs, functional categories, scale-only,
# estimate-freqs, empirical rate variation, reverse-groups,
# expected subs, column-probs, windows

phastCons:
	@echo "*** Testing phastCons ***"
	phastCons hpmrc.ss hpmrc-rev-dg-global.mod --nrates 20 --transitions .08,.008 --quiet --viterbi elements.bed --seqname chr22 > cons.dat
	@if [[ -n `diff --brief cons.dat cons_correct.dat` ]] ; then echo "ERROR" ; exit 1 ; fi  
	@if [[ -n `diff --brief elements.bed elements_correct.bed` ]] ; then echo "ERROR" ; exit 1 ; fi  
	tree_doctor hpmrc-rev-dg-global.mod --prune galGal2 > hpmr.mod
	phastCons hpmrc.ss hpmr.mod --nrates 20 --transitions .08,.008 --quiet --viterbi elements-4way.bed --seqname chr22 > cons-4way.dat
	@if [[ -n `diff --brief cons-4way.dat cons-4way_correct.dat` ]] ; then echo "ERROR" ; exit 1 ; fi  
	@if [[ -n `diff --brief elements-4way.bed elements-4way_correct.bed` ]] ; then echo "ERROR" ; exit 1 ; fi  
	@echo -e "Passed all tests.\n"
	@rm -f cons.dat cons-4way.dat elements.bed elements-4way.bed hpmr.mod

# still need to test estimation of MLE for transition probs, coding potential, felsenstein/churchill model

# msa_split

# refeature

# exoniphy


phyloP:
	phyloFit hmrc.ss --tree "(human, (mouse,rat), cow)" -i SS --quiet
	phyloP --null 10 phyloFit.mod > phyloP_null_test.txt
	phyloP -i SS phyloFit.mod hmrc.ss > phyloP_sph_test.txt
	phyloP -i SS --method LRT phyloFit.mod hmrc.ss > phyloP_lrt_test.txt
        phyloP -i SS --method LRT --mode CONACC phyloFit.mod hmrc.ss > phyloP_lrt_conacc_test.txt
	phyloP -i SS --method GERP phyloFit.mod hmrc.ss > phyloP_gerp_test.txt
	phyloP -i SS --method SCORE phyloFit.mod hmrc.ss > phyloP_score_test.txt
	phyloP -i SS --method LRT --wig-scores phyloFit.mod hmrc.ss > phyloP_wig_test.wig
	phyloP -i SS --method LRT --base-by-base phyloFit.mod hmrc.ss > phyloP_basebybase_test.txt
	phyloP -i SS --method SCORE --wig-scores --refidx 2 phyloFit.mod hmrc.ss > phyloP_refidx_test.txt
	echo -e "chr1\t0\t10\nchr1\t50\t100\nchr1\t200\t300" > temp.bed
	phyloP -i SS --method LRT --mode CONACC --features temp.bed phyloFit.mod hmrc.ss > phyloP_features_test.txt
	phyloP -i SS --method SCORE --features temp.bed -g phyloFit.mod hmrc.ss > phyloP_gff_test.gff
	tree_doctor --name-ancestors phyloFit.mod > phyloFit-named.mod

# show output of phastCons test cases as tracks (run on hgwdev)
show-cons:
	wigAsciiToBinary -chrom=chr22 -wibFile=chr22_phastConsTest cons_correct.dat
	hgLoadWiggle hg16 phastConsTest chr22_phastConsTest.wig
	mv chr22_phastConsTest.wib /gbdb/hg16/wib
	hgLoadBed hg16 phastConsElementsTest elements_correct.bed
	rm chr22_phastConsTest.wig


# Here are a few cases to make sure idx_offset of maf_read is working ok (should do
# more testing when maf changes are complete)
mafread:
	msa_view -i MAF chr22.14500000-15500000.maf > test.fa
	msa_view -i MAF test.maf > test.fa
	msa_view -i MAF -o SS test.maf > test.ss
	msa_split -i MAF --by-index 7,295 --out-root splitTest -o SS test.maf

=== src/phastMotif/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..
# assume executable name is given by directory name
EXEC = $(addprefix ${BIN}/,$(notdir ${PWD}))

# assume all *.c files are source
SRCS = $(basename $(wildcard *.c))
OBJS =  $(addsuffix .o,${SRCS})

all: ${EXEC}

%.o: %.c ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXEC}: ${OBJS} ${PHAST}/lib/libphast.a
	${CC} ${LFLAGS} ${LIBPATH} -o $@ ${OBJS} ${LIBS} 

clean: 
	rm -f *.o ${EXEC}

=== src/prequel/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..

# assume executable name is given by directory name
PROGS = pbsDecode pbsEncode pbsScoreMatrix pbsTrain prequel
MODULES = simplex_grid pbs_code
EXEC = $(addprefix ${BIN}/,${PROGS})

# assume all *.c files are source
OBJS =  $(addsuffix .o,${PROGS} ${MODULES})
OBJS_MODULES =  $(addsuffix .o,${MODULES})
HELP = $(addsuffix .help,$(basename $(wildcard *.help_src)))

%.o : %.c
# (cancels built-in rule; otherwise gets used instead if *.help missing)
.SECONDARY : ${HELP}
# (prevents *.help from being deleted as a intermediate file)

all: ${EXEC}

%.o : %.c ${HELP} ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXEC} : ${BIN}/%: %.o ${PHAST}/lib/libphast.a ${OBJS_MODULES}
	${CC} ${LFLAGS} ${LIBPATH} -o $@ $< ${OBJS_MODULES} ${LIBS} 

%.help : %.help_src
	../munge-help.sh $< > $@

clean: 
	rm -f *.o ${EXEC} ${HELP}

=== debian/changelog ===
phast (1.4+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #875555)

 -- Andreas Tille <tille@debian.org>  Tue, 12 Sep 2017 10:11:38 +0200

=== debian/control ===
Source: phast
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               liblapack-dev,
               libblas-dev,
               libtmglib-dev,
               libpcre3-dev,
               help2man
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/phast.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/phast.git
Homepage: http://compgen.cshl/edu/phast

Package: phast
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: phylogenetic analysis with space/time models
 PHAST is a software package for comparative and evolutionary genomics.
 It consists of about half a dozen major programs, plus more than a dozen
 utilities for manipulating sequence alignments, phylogenetic trees, and
 genomic annotations. For the most part, PHAST focuses on two kinds of
 applications: the identification of novel functional elements, including
 protein-coding exons and evolutionarily conserved sequences; and
 statistical phylogenetic modeling, including estimation of model
 parameters, detection of signatures of selection, and reconstruction of
 ancestral sequences.
 .
 PHAST does not support phylogeny reconstruction or sequence alignment,
 and it is designed for use with DNA sequences only (see Comparison).

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	cd src && make clean

## phast 1.5%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -10,3 +10,8 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	cd src && make clean
+
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	cd test && PATH=$(CURDIR)/bin:$(PATH) make msa_view
+endif

## phast 1.5+dfsg

=== src/lib/base/Makefile ===
include ../../make-include.mk
PHAST := ${PHAST}/../..

# assume every *.c file goes in the library
OBJS =  $(addsuffix .o,$(basename $(wildcard *.c)))

all: ${TARGETLIB}(${OBJS}) 

sharedlib: CFLAGS += -fPIC
sharedlib: all

%.o: %.c ../../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${TARGETLIB}(${OBJS}) : ${OBJS} 
	${AR} rs ${TARGETLIB} $?

clean:
	rm -f *.o

=== src/lib/feature/Makefile ===
include ../../make-include.mk
PHAST := ${PHAST}/../..

# assume every *.c file goes in the library
OBJS =  $(addsuffix .o,$(basename $(wildcard *.c)))

all: ${TARGETLIB}(${OBJS})

sharedlib: CFLAGS += -fPIC
sharedlib: all

%.o: %.c ../../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${TARGETLIB}(${OBJS}) : ${OBJS} 
	${AR} rs ${TARGETLIB} $?

clean:
	rm -f *.o

=== debian/changelog ===
phast (1.5+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add patch to fix tests on arm64 (Closes: #911983)

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 03 Oct 2020 12:51:30 +0530

phast (1.5+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Fix homepage
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Run part or the test suite

 -- Andreas Tille <tille@debian.org>  Fri, 19 Oct 2018 09:10:34 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                liblapack-dev,
                libblas-dev,
                libtmglib-dev,
                libpcre3-dev,
                help2man
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/phast.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/phast.git
-Homepage: http://compgen.cshl/edu/phast
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/phast
+Vcs-Git: https://salsa.debian.org/med-team/phast.git
+Homepage: http://compgen.cshl.edu/phast/
+Rules-Requires-Root: no
 
 Package: phast
 Architecture: any

## phast 1.6%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               liblapack-dev,
-               libblas-dev,
+               liblapack-dev | liblapack.so,
+               libblas-dev | libblas.so,
                libtmglib-dev,
-               libpcre3-dev,
+               libpcre2-dev,
                help2man
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/phast
 Vcs-Git: https://salsa.debian.org/med-team/phast.git
 Homepage: http://compgen.cshl.edu/phast/

## phast 1.6+dfsg

=== src/dless/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..

#EXEC = $(addprefix ${BIN}/,$(notdir ${PWD}))
PROGS = dless dlessP
MODULES = bd_phylo_hmm
EXEC = $(addprefix ${BIN}/,${PROGS})

# assume all *.c files are source
OBJS =  $(addsuffix .o,${PROGS} ${MODULES})
OBJS_MODULES =  $(addsuffix .o,${MODULES})
HELP = $(addsuffix .help,$(basename $(wildcard *.help_src)))

%.o : %.c
# (cancels built-in rule; otherwise gets used instead if *.help missing)
.SECONDARY : ${HELP}
# (prevents *.help from being deleted as an intermediate file)

all: ${EXEC}

%.o: %.c ${HELP} ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXEC}: ${BIN}/%: %.o ${OBJS_MODULES} ${PHAST}/lib/libphast.a
	${CC} ${LFLAGS} ${LIBPATH} -o $@ $< ${OBJS_MODULES} ${LIBS} 

%.help : %.help_src
	../munge-help.sh $< > $@

clean: 
	rm -f *.o ${HELP} ${EXEC}

=== src/util/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..

# assume every *.c file represents an executable
EXECS = $(addprefix ${BIN}/,$(basename $(wildcard *.c)))
OBJS =  $(addsuffix .o,${EXECS})
HELP = $(addsuffix .help,$(basename $(wildcard *.help_src)))

%.o : %.c
# (cancels built-in rule; otherwise gets used instead if *.help missing)
.SECONDARY : ${HELP}
# (prevents *.help from being deleted as a intermediate file)

all: ${EXECS}

%.o: %.c ${HELP} ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXECS}: ${BIN}/%: %.o ${PHAST}/lib/libphast.a
	${CC} ${LIBPATH} ${LFLAGS} -o $@ $< ${LIBS} 

%.help : %.help_src
	../munge-help.sh $< > $@

clean: 
	rm -f *.o *.help ${EXECS}

=== debian/changelog ===
phast (1.6+dfsg-3) unstable; urgency=medium

  * Port to pcre2
    Closes: #1000000, #1000163

 -- Andreas Tille <tille@debian.org>  Fri, 19 Nov 2021 13:17:54 +0100

phast (1.6+dfsg-2) unstable; urgency=medium

  * Build-Depends: s/libpcre3-dev/libpcre2-dev/
    Closes: #1000000
  * Add autopkgtest

 -- Andreas Tille <tille@debian.org>  Thu, 18 Nov 2021 14:52:47 +0100

phast (1.6+dfsg-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github (routine-update)
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * watch file standard 4 (routine-update)
  * Build-Depends: libf2c2-dev, libatlas-base-dev

 -- Andreas Tille <tille@debian.org>  Mon, 30 Aug 2021 21:53:58 +0200

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,14 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               liblapack-dev | liblapack.so,
-               libblas-dev | libblas.so,
+               liblapack-dev,
+               libblas-dev,
                libtmglib-dev,
                libpcre2-dev,
+               libf2c2-dev,
+               libatlas-base-dev,
                help2man
-Standards-Version: 4.6.2
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/phast
 Vcs-Git: https://salsa.debian.org/med-team/phast.git
 Homepage: http://compgen.cshl.edu/phast/

=== debian/rules ===
--- 
+++ 
@@ -15,3 +15,7 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	cd test && PATH=$(CURDIR)/bin:$(PATH) make msa_view
 endif
+
+override_dh_installexamples:
+	dh_installexamples
+	find debian/*/usr/share/doc/*/examples -type f -size +1k -exec xz \{\} \;

## phast 1.7%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: phast
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               liblapack-dev,
-               libblas-dev,
+               liblapack-dev | liblapack.so,
+               libblas-dev | libblas.so,
+               liblapacke-dev,
                libtmglib-dev,
                libpcre2-dev,
-               libf2c2-dev,
-               libatlas-base-dev,
                help2man
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/phast
 Vcs-Git: https://salsa.debian.org/med-team/phast.git
 Homepage: http://compgen.cshl.edu/phast/

## phast 1.7+dfsg

=== src/Makefile ===
include make-include.mk

SUB = lib dless exoniphy phastCons phastOdds phastMotif phyloFit phyloBoot phyloP prequel util 

CDIR = ${PWD}

all: 
	mkdir -p ../bin ../lib
	for dir in $(SUB) ; do cd ${CDIR}/$$dir && ${MAKE} ; done	
ifeq ($(TARGETOS), Windows)
	@for file in `ls ../bin` ; do mv ../bin/$$file ../bin/$$file.exe ; done
else
	mkdir -p ../doc/man/
	@echo "Generating man pages..."
	@for file in `ls ../bin` ; do perl help2man.pl ../bin/$$file ../doc/man/ ; done
	@echo "Done."
endif

sharedlib:
	cd ${CDIR}/lib && ${MAKE} sharedlib 
	gcc ${CFLAGS} -shared ${LFLAGS} ${LIBPATH} -o libphast.so `find lib/ -name "*.o"` ${LIBS}
	mkdir -p ../lib/sharedlib
	mv libphast.so ../lib/sharedlib/

install:
ifndef DESTDIR
	DESTDIR=/
endif
	mkdir -p ${DESTDIR}/usr/bin/
	mkdir -p ${DESTDIR}/opt/phast/data/
	mkdir -p ${DESTDIR}/usr/share/man/man1/
	cp ../bin/* ${DESTDIR}/usr/bin/
	cp -R ../data/* ${DESTDIR}/opt/phast/data/
	cp -R ../doc/man/* ${DESTDIR}/usr/share/man/man1/

doc:
	cd ../; make doc 

clean:
	@for dir in $(SUB) ; do cd ${CDIR}/$$dir && ${MAKE} clean ; done
	rm -rf ../bin ../lib ../doc

manpages:
	@for file in `ls ../bin` ; do perl help2man.pl ../bin/$$file ; done

=== test/Makefile ===
# acs 8/4/04
# simple test cases, designed to catch obvious errors
# add cases as needed

all: msa_view phyloFit phastCons

msa_view:
	@echo "*** Testing msa_view ***"
	msa_view hmrc.ss -i SS --end 10000 > hmrc.fa
	if ! diff --brief hmrc.fa hmrc_correct.fa ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.fa -o PHYLIP > hmrc.ph
	msa_view hmrc.ph -i PHYLIP > hmrc.fa
	if ! diff --brief hmrc.fa hmrc_correct.fa ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ph --out-format MPM --in-format PHYLIP > hmrc.mpm
	msa_view hmrc.mpm --in-format MPM > hmrc.fa
	if ! diff --brief hmrc.fa hmrc_correct.fa ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.fa -o SS > hmrc_short_a.ss
	msa_view hmrc.ss --end 10000 -i SS -o SS > hmrc_short_b.ss
	if ! diff --brief hmrc_short_[ab].ss ; then echo "ERROR" ; exit 1 ; fi
	msa_view --seqs human,cow hmrc_short_a.ss -i SS -o SS | msa_view - -i SS > hm_a.fa
	msa_view --seqs human,cow hmrc.fa > hm_b.fa
	if ! diff --brief hm_[ab].fa ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss --gap-strip ANY -i SS -o SS | msa_view - -i SS > hmrc_nogaps_a.fa
	msa_view hmrc.ss -i SS | msa_view - --gap-strip ANY > hmrc_nogaps_b.fa
	if ! diff --brief hmrc_nogaps_[ab].fa ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.fa --seqs human,cow --gap-strip ALL > hm_a.fa
	msa_view hmrc_short_a.ss --seqs human,cow -i SS --gap-strip ALL > hm_b.fa
	if ! diff --brief hm_[ab].fa ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss --start 10000 --end 20000 -i SS > hmrc_sub_a.fa
	msa_view hmrc.ss -i SS | msa_view - --start 10000 --end 20000 > hmrc_sub_b.fa
	if ! diff --brief hmrc_sub_[ab].fa ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss --summary -i SS > hmrc_summary
	if ! diff --brief -b hmrc_summary hmrc_summary_correct ; then echo "ERROR" ; exit 1 ; fi
	@echo -e "Passed all tests.\n"
	@rm -f hmrc.ph hmrc.fa hmrc.mpm hmrc_short_[ab].ss hm_[ab].fa hmrc_nogaps_[ab].fa hmrc_sub_[ab].fa hmrc_summary


# still need test for MAFs, reverse complement, aggregate, dinucs,
# category-specific stats, missing data, reorder rows.  Also, maybe
# should choose a better short test case (first 10000 bases all gaps
# in mouse and rat)

phyloFit:
	@echo "*** Testing phyloFit ***"
	phyloFit hmrc.ss --subst-mod JC69 --tree "(human, (mouse,rat), cow)" -i SS --quiet
	if ! diff --brief phyloFit.mod jc.mod ; then echo "Rounding errors found" ; diff -u phyloFit.mod jc.mod ; fi
	phyloFit hmrc.ss --subst-mod JC69 --tree "((((human,chimp), (mouse,rat)), cow), chicken)" -i SS --quiet
	if ! diff --brief phyloFit.mod jc.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod F81 --tree "(human, (mouse,rat), cow)" -i SS --quiet
	if ! diff --brief phyloFit.mod f81.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod HKY85 --tree "(human, (mouse,rat), cow)" -i SS --quiet
	if ! diff --brief phyloFit.mod hky.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat), cow)" -i SS --quiet
	if ! diff --brief phyloFit.mod rev.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod UNREST --tree "(human, (mouse,rat), cow)" -i SS --quiet
	if ! diff --brief phyloFit.mod unrest.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod HKY85 --tree "(human, (mouse,rat), cow)" -i SS -k 4 --quiet
	if ! diff --brief phyloFit.mod hky-dg.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat), cow)" -i SS -k 4 --quiet 
	if ! diff --brief phyloFit.mod rev-dg.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod HKY85 --tree "(human, (mouse,rat), cow)" -i SS --EM --quiet
	if ! diff --brief phyloFit.mod hky-em.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat), cow)" -i SS --EM --quiet
	if ! diff --brief phyloFit.mod rev-em.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hpmrc.ss --subst-mod REV --tree "(hg16, (mm3,rn3), galGal2)" -i SS --gaps-as-bases --quiet
	if ! diff --brief phyloFit.mod rev-gaps.mod ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV -i SS --init-model rev.mod --post-probs --lnl --quiet
	if ! diff --brief phyloFit.mod rev-lnl.mod ; then echo "ERROR" ; exit 1 ; fi
	if ! diff --brief phyloFit.postprob rev.postprob ; then echo "ERROR" ; exit 1 ; fi
	phyloFit hmrc.ss --subst-mod REV --tree "(human, (mouse,rat))" -i SS --quiet
	if ! diff --brief phyloFit.mod rev-hmr.mod ; then echo "ERROR" ; exit 1 ; fi
	msa_view hmrc.ss -i SS --seqs human,mouse,rat --unordered -o SS > hmr.ss
	phyloFit hmr.ss -i SS --quiet
	if ! diff --brief phyloFit.mod rev-hmr2.mod ; then echo "ERROR" ; exit 1 ; fi  # FIXME: rev-hmr.mod and rev-hmr2.mod should be equal (eq freqs being obtained from all seqs)
	msa_view hmrc.ss -i SS --seqs human,mouse --unordered -o SS > hm.ss
	phyloFit hm.ss -i SS --quiet
	if ! diff --brief phyloFit.mod rev-hm.mod ; then echo "ERROR" ; exit 1 ; fi  
	phyloFit hmrc.ss --subst-mod UNREST --tree "((human, mouse), cow)" -i SS --ancestor cow --quiet
	if ! diff --brief phyloFit.mod unrest-cow-anc.mod ; then echo "ERROR" ; exit 1 ; fi
	@echo -e "Passed all tests.\n"
	@rm -f phyloFit.mod phyloFit.postprob hmr.ss hm.ss

# still need tests for dinucs, functional categories, scale-only,
# estimate-freqs, empirical rate variation, reverse-groups,
# expected subs, column-probs, windows

phastCons:
	@echo "*** Testing phastCons ***"
	phastCons hpmrc.ss hpmrc-rev-dg-global.mod --nrates 20 --transitions .08,.008 --quiet --viterbi elements.bed --seqname chr22 > cons.dat
	if ! diff --brief cons.dat cons_correct.dat ; then echo "ERROR" ; exit 1 ; fi  
	if ! diff --brief elements.bed elements_correct.bed ; then echo "ERROR" ; exit 1 ; fi  
	tree_doctor hpmrc-rev-dg-global.mod --prune galGal2 > hpmr.mod
	phastCons hpmrc.ss hpmr.mod --nrates 20 --transitions .08,.008 --quiet --viterbi elements-4way.bed --seqname chr22 > cons-4way.dat
	if ! diff --brief cons-4way.dat cons-4way_correct.dat ; then echo "ERROR" ; exit 1 ; fi  
	if ! diff --brief elements-4way.bed elements-4way_correct.bed ; then echo "ERROR" ; exit 1 ; fi  
	@echo -e "Passed all tests.\n"
	@rm -f cons.dat cons-4way.dat elements.bed elements-4way.bed hpmr.mod

# still need to test estimation of MLE for transition probs, coding potential, felsenstein/churchill model

# msa_split

# refeature

# exoniphy


phyloP:
	phyloFit hmrc.ss --tree "(human, (mouse,rat), cow)" -i SS --quiet
	phyloP --null 10 phyloFit.mod > phyloP_null_test.txt
	phyloP -i SS phyloFit.mod hmrc.ss > phyloP_sph_test.txt
	phyloP -i SS --method LRT phyloFit.mod hmrc.ss > phyloP_lrt_test.txt
	phyloP -i SS --method LRT --mode CONACC phyloFit.mod hmrc.ss > phyloP_lrt_conacc_test.txt
	phyloP -i SS --method GERP phyloFit.mod hmrc.ss > phyloP_gerp_test.txt
	phyloP -i SS --method SCORE phyloFit.mod hmrc.ss > phyloP_score_test.txt
	phyloP -i SS --method LRT --wig-scores phyloFit.mod hmrc.ss > phyloP_wig_test.wig
	phyloP -i SS --method LRT --base-by-base phyloFit.mod hmrc.ss > phyloP_basebybase_test.txt
	phyloP -i SS --method SCORE --wig-scores --refidx 2 phyloFit.mod hmrc.ss > phyloP_refidx_test.txt
	echo -e "chr1\t0\t10\nchr1\t50\t100\nchr1\t200\t300" > temp.bed
	phyloP -i SS --method LRT --mode CONACC --features temp.bed phyloFit.mod hmrc.ss > phyloP_features_test.txt
	phyloP -i SS --method SCORE --features temp.bed -g phyloFit.mod hmrc.ss > phyloP_gff_test.gff
	tree_doctor --name-ancestors phyloFit.mod > phyloFit-named.mod

# show output of phastCons test cases as tracks (run on hgwdev)
show-cons:
	wigAsciiToBinary -chrom=chr22 -wibFile=chr22_phastConsTest cons_correct.dat
	hgLoadWiggle hg16 phastConsTest chr22_phastConsTest.wig
	mv chr22_phastConsTest.wib /gbdb/hg16/wib
	hgLoadBed hg16 phastConsElementsTest elements_correct.bed
	rm chr22_phastConsTest.wig


# Here are a few cases to make sure idx_offset of maf_read is working ok (should do
# more testing when maf changes are complete)
mafread:
	msa_view -i MAF chr22.14500000-15500000.maf > test.fa
	msa_view -i MAF test.maf > test.fa
	msa_view -i MAF -o SS test.maf > test.ss
	msa_split -i MAF --by-index 7,295 --out-root splitTest -o SS test.maf

=== src/exoniphy/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..
# assume executable name is given by directory name
EXEC = $(addprefix ${BIN}/,$(notdir ${PWD}))

# assume all *.c files are source
SRCS = $(basename $(wildcard *.c))
OBJS =  $(addsuffix .o,${SRCS})
HELP = $(addsuffix .help,$(basename $(wildcard *.help_src)))

%.o : %.c
# (cancels built-in rule; otherwise gets used instead if *.help missing)
.SECONDARY : ${HELP}
# (prevents *.help from being deleted as a intermediate file)

all: ${EXEC}

%.o: %.c ${HELP} ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXEC}: ${OBJS} ${PHAST}/lib/libphast.a
	${CC} ${LFLAGS} ${LIBPATH} -o $@ ${OBJS} ${LIBS} 

%.help : %.help_src
	../munge-help.sh $< > $@

clean: 
	rm -f *.o *.help ${EXEC}

=== src/lib/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..

CDIR = ${PWD}

PACKAGES=base msa feature hmm phylo phylo_hmm motif pcre

ifdef RPHAST
PACKAGES += rphast
endif


ifdef CLAPACKPATH		# only do below if using CLAPACK

all: liblinks phastlib

sharedlib: liblinks sharedphastlib

# by default, CLAPACK uses non-standard library names, which confuses
# the compiler.  We'll just create symbolic links in ${PHAST}/lib that
# have proper names
liblinks: ${PHAST}/lib/liblapack.a ${PHAST}/lib/libtmg.a \
	${PHAST}/lib/libblaswr.a 

${PHAST}/lib/liblapack.a: ${CLAPACKPATH}/lapack${PLAT}.a
	mkdir -p ${PHAST}/lib
	${LN} -s $< $@

${PHAST}/lib/libtmg.a: ${CLAPACKPATH}/tmglib${PLAT}.a
	mkdir -p ${PHAST}/lib
	${LN} -s $< $@

${PHAST}/lib/libblaswr.a: ${CLAPACKPATH}/blas${PLAT}.a
	mkdir -p ${PHAST}/lib
	${LN} -s $< $@

else				# no CLAPACK: links not necessary

all: phastlib

sharedlib: sharedphastlib

endif

phastlib:
	for dir in ${PACKAGES}; do cd ${CDIR}/$$dir && ${MAKE} ; done

sharedphastlib:
	for dir in ${PACKAGES}; do cd ${CDIR}/$$dir && ${MAKE} sharedlib ; done

clean:
	for dir in ${PACKAGES}; do cd ${CDIR}/$$dir && ${MAKE} clean ; done
	rm -f ${PHAST}/lib/*

=== src/phastCons/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..
# assume executable name is given by directory name
EXEC = $(addprefix ${BIN}/,$(notdir ${PWD}))

# assume all *.c files are source
SRCS = $(basename $(wildcard *.c))
OBJS =  $(addsuffix .o,${SRCS})
HELP = $(addsuffix .help,$(basename $(wildcard *.help_src)))

%.o : %.c
# (cancels built-in rule; otherwise gets used instead if *.help missing)
.SECONDARY : ${HELP}
# (prevents *.help from being deleted as an intermediate file)

all: ${EXEC}

%.o : %.c ${HELP} ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXEC} : ${OBJS} ${PHAST}/lib/libphast.a
	${CC} ${LFLAGS} ${LIBPATH} -o $@ ${OBJS} ${LIBS} 

%.help : %.help_src
	../munge-help.sh $< > $@

clean: 
	rm -f *.o ${EXEC} ${HELP}

=== src/prequel/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # assume executable name is given by directory name
 PROGS = pbsDecode pbsEncode pbsScoreMatrix pbsTrain prequel
-MODULES = simplex_grid pbs_code
+MODULES = phast_simplex_grid phast_pbs_code
 EXEC = $(addprefix ${BIN}/,${PROGS})
 
 # assume all *.c files are source

=== src/lib/rphast/Makefile ===
include ../../make-include.mk
PHAST := ${PHAST}/../..

# assume every *.c file goes in the library
OBJS =  $(addsuffix .o,$(basename $(wildcard *.c)))

all: ${TARGETLIB}(${OBJS})

%.o: %.c ../../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ -DRPHAST 

${TARGETLIB}(${OBJS}) : ${OBJS} 
	${AR} rs ${TARGETLIB} $?

clean:
	rm -f *.o

=== debian/changelog ===
phast (1.7+dfsg-3) unstable; urgency=medium

  * Team Upload.
  * Fixup FTBFS with gcc-15 (Closes: #1097575)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 20 Sep 2025 03:01:50 +0530

phast (1.7+dfsg-2) unstable; urgency=medium

  * d/rules: use $(MAKE) to avoid interference with the jobserver.
  * make.patch: new: fix build parallelism issues.
    Several makefiles collide on editing the libphast.a, so this patch
    blocks the parallelism on that target. (Closes: #1091563)
  * gcc-14.patch: declare forwarding unneeded.
  * d/patches/*: normalize the last-update timestamp.
  * hardening.patch: add support for CPPFLAGS.
    This fixes remaining issues left in binaries hardening.

 -- Étienne Mollier <emollier@debian.org>  Sun, 05 Jan 2025 21:16:07 +0100

phast (1.7+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 06 Dec 2024 21:33:23 +0100

phast (1.6+dfsg-6) unstable; urgency=medium

  * gcc-14.patch: fix build failure with gcc 14. (Closes: #1075383)
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.
  * d/p/clapack.patch: convert e acute to UTF-8.

 -- Étienne Mollier <emollier@debian.org>  Wed, 31 Jul 2024 22:24:23 +0200

phast (1.6+dfsg-5) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix FTBFS due to -Werror-implicit-function-declaration
    (Closes: #1066451)
  * Added B-D on lapacke-dev for porting functions to lapack equivalents

 -- Nilesh Patra <nilesh@iki.fi>  Tue, 26 Mar 2024 15:19:11 +0530

phast (1.6+dfsg-4) unstable; urgency=medium

  [ Andreas Tille ]
  * s/libatlas-base-dev/liblapacke-dev/ in Build-Depends to use LAPACKE
    instead of clapack
  * Provide alternative Build-Depends to liblapack-dev and libblas-dev
  * Standards-Version: 4.6.2 (routine-update)
  * Upstream email removed from d/copyright since its bouncing

  [ Sébastien Villemot ]
  * Complete migration away from ATLAS
    Closes: #1056681

 -- Andreas Tille <tille@debian.org>  Wed, 29 Nov 2023 10:25:18 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	cd src && $(MAKE) clean

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd test && PATH=$(CURDIR)/bin:$(PATH) $(MAKE) msa_view
endif

override_dh_installexamples:
	dh_installexamples
	find debian/*/usr/share/doc/*/examples -type f -size +1k -exec xz \{\} \;

## phast 1.8%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,10 @@
                libtmglib-dev,
                libpcre2-dev,
                help2man
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/phast
 Vcs-Git: https://salsa.debian.org/med-team/phast.git
 Homepage: http://compgen.cshl.edu/phast/
-Rules-Requires-Root: no
 
 Package: phast
 Architecture: any

## phast 1.8+dfsg

=== src/dless/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 #EXEC = $(addprefix ${BIN}/,$(notdir ${PWD}))
 PROGS = dless dlessP
-MODULES = bd_phylo_hmm
+MODULES = phast_bd_phylo_hmm
 EXEC = $(addprefix ${BIN}/,${PROGS})
 
 # assume all *.c files are source

=== src/phyloFit/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..

# assume executable name is given by directory name
EXEC = $(addprefix ${BIN}/,$(notdir ${PWD}))

# assume all *.c files are source
SRCS = $(basename $(wildcard *.c))
OBJS =  $(addsuffix .o,${SRCS})
HELP = $(addsuffix .help,$(basename $(wildcard *.help_src)))

%.o : %.c
# (cancels built-in rule; otherwise gets used instead if *.help missing)
.SECONDARY : ${HELP}
# (prevents *.help from being deleted as an intermediate file)

all: ${EXEC}

%.o: %.c ${HELP} ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXEC}: ${OBJS} ${PHAST}/lib/libphast.a
	${CC} ${LFLAGS} ${LIBPATH} -o $@ ${OBJS} ${LIBS} 

%.help : %.help_src
	../munge-help.sh $< > $@

clean: 
	rm -f *.o ${EXEC} ${HELP}

=== src/phyloP/Makefile ===
include ../make-include.mk
PHAST := ${PHAST}/..

# assume executable name is given by directory name
EXEC = $(addprefix ${BIN}/,$(notdir ${PWD}))

# assume all *.c files are source
SRCS = $(basename $(wildcard *.c))
OBJS =  $(addsuffix .o,${SRCS})
HELP = $(addsuffix .help,$(basename $(wildcard *.help_src)))

%.o : %.c
# (cancels built-in rule; otherwise gets used instead if *.help missing)
.SECONDARY : ${HELP}
# (prevents *.help from being deleted as a intermediate file)

all: ${EXEC}

%.o : %.c ${HELP} ../make-include.mk
	$(CC) $(CFLAGS) -c $< -o $@ 

${EXEC} : ${OBJS} ${PHAST}/lib/libphast.a
	${CC} ${LFLAGS} ${LIBPATH} -o $@ ${OBJS} ${LIBS} 

%.help : %.help_src
	../munge-help.sh $< > $@

clean: 
	rm -f *.o ${EXEC} ${HELP}

=== debian/changelog ===
phast (1.8+dfsg-1) unstable; urgency=medium

  * New upstream version 1.8+dfsg
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/rules: slight readability improvements.
  * d/watch convert to v5 Github template.

 -- Étienne Mollier <emollier@debian.org>  Sat, 15 Nov 2025 10:32:38 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	cd src \
	&& $(MAKE) clean

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd test \
	&& PATH=$(CURDIR)/bin:$(PATH) \
		$(MAKE) msa_view
endif

override_dh_installexamples:
	dh_installexamples
	find debian/*/usr/share/doc/*/examples \
		-type f \
		-size +1k \
		-exec xz \{\} \;

=== debian/watch ===
Version: 5

Template: Github
Owner: CshlSiepelLab
Project: phast
Repack: yes
Repacksuffix: +dfsg
Dversionmangle: auto
Compression: xz
